/* Software floating-point emulation.
   Return a converted to IEEE quad
   Copyright (C) 2004 Free Software Foundation, Inc.
   This file is part of the GNU C Library.

   The GNU C Library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2.1 of the License, or (at your option) any later version.

   The GNU C Library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.

   You should have received a copy of the GNU Lesser General Public
   License along with the GNU C Library; if not, write to the Free
   Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
   02111-1307 USA.  */

#include "soft-fp.h"
#include "extended.h"
#include "quad.h"

quad_double __extendxftf2(long double a)
{
  FP_DECL_EX;
  FP_DECL_E(A);
  FP_DECL_Q(R);
  quad_double r;

  FP_INIT_ROUNDMODE;
  FP_UNPACK_E(A, a);
#if (2 * _FP_W_TYPE_SIZE) < _FP_FRACBITS_Q
  FP_CONV(Q,E,4,4,R,A);
#else
  FP_CONV(Q,E,2,2,R,A);
#endif
  FP_PACK_Q(r, R);
  FP_HANDLE_EXCEPTIONS;

  return r;
}
