/* `HUGE_VALQ' constant for IEEE 754 machines (where it is infinity).
   Used by <stdlib.h> and <math.h> functions for overflow.
   Copyright (C) 2004
   Free Software Foundation, Inc.
   This file is part of the GNU C Library.

   The GNU C Library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2.1 of the License, or (at your option) any later version.

   The GNU C Library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.

   You should have received a copy of the GNU Lesser General Public
   License along with the GNU C Library; if not, write to the Free
   Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
   02111-1307 USA.  */

#ifndef _MATH_H
# error "Never use <bits/huge_valq.h> directly; include <math.h> instead."
#endif

/* IEEE positive infinity (-HUGE_VAL is negative infinity).  */

#include <endian.h>

typedef union { unsigned char __c[16]; __float128 __qd; } __huge_valq_t;

#if __BYTE_ORDER == __BIG_ENDIAN
# define __HUGE_VALQ_bytes	{ 0x7f, 0xff, 0,0,0,0,0,0,0,0,0,0,0,0,0,0 }
#endif
#if __BYTE_ORDER == __LITTLE_ENDIAN
# define __HUGE_VALQ_bytes	{ 0,0,0,0,0,0,0,0,0,0,0,0,0,0, 0xff, 0x7f }
#endif

#ifdef __GNUC__
# define HUGE_VALQ	(__extension__ \
			 ((__huge_valq_t) { __c : __HUGE_VALQ_bytes }).__qd)
#else
static __huge_valq_t __huge_valq = { __HUGE_VALQ_bytes };
# define HUGE_VALQ	(__huge_valq.__qd)
#endif
