/* Copyright (C) 2004 Free Software Foundation, Inc.
   This file is part of the GNU C Library.

   The GNU C Library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2.1 of the License, or (at your option) any later version.

   The GNU C Library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.

   You should have received a copy of the GNU Lesser General Public
   License along with the GNU C Library; if not, write to the Free
   Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
   02111-1307 USA.  */

#include <math.h>
#ifdef USE_WIDE_CHAR
# include <wchar.h>
#endif
#include <endian.h>
#include <ieee754-quad.h>
#include <bits/huge_valq.h>

/* The actual implementation for all floating point sizes is in strtod.c.
   These macros tell it to produce the `IEEE quad' version, `strtoq'.  */

#define FLOAT		__float128
#define FLT		QUAD
#ifdef USE_WIDE_CHAR
# define STRTOF		wcstoqd_l
# define __STRTOF	__wcstoqd_l
#else
# define STRTOF		strtoqd_l
# define __STRTOF	__strtoqd_l
#endif
#define MPN2FLOAT	__mpn_construct_float128
#ifndef FLOAT_HUGE_VAL
# define FLOAT_HUGE_VAL	HUGE_VALQ
#endif
#define SET_MANTISSA(flt, mant) \
  do { union ieee854_float128 u;					      \
       u.d = (flt);							      \
       u.ieee.mantissa0 = 0x8000;					      \
       u.ieee.mantissa1 = 0;						      \
       u.ieee.mantissa2 = ((mant) >> 32);	      			      \
       u.ieee.mantissa3 = (mant) & 0xffffffff;				      \
       (flt) = u.d;							      \
  } while (0)

#include <stdlib/strtod_l.c>
